import { Ctor } from 'everyday-types';
declare type AnyFn = (x: any) => any;
declare type Entry = {
    $r: number;
    $t: string;
    $v: any;
};
declare type Ptr = {
    $p: number;
};
export declare const thru: (x: any) => any;
export declare const createContext: (extraTypes?: [Ctor, [AnyFn, AnyFn]][]) => {
    replacer: (top: unknown, clear?: boolean) => (this: any, key: string) => string | Entry | Ptr;
    reviver: (classes: Ctor[], refs?: Map<number, object>, pending?: Map<number, Set<[any, string | ((result: any) => void)]>>) => (this: any, key: string, value: any) => any;
};
export declare const replacer: (top: unknown, clear?: boolean) => (this: any, key: string) => string | Entry | Ptr, reviver: (classes: Ctor[], refs?: Map<number, object>, pending?: Map<number, Set<[any, string | ((result: any) => void)]>>) => (this: any, key: string, value: any) => any;
export declare const serialize: (any: unknown, indent?: number, clear?: boolean) => string;
export declare const deserialize: (serialized: string, classes?: Ctor[]) => unknown;
export {};
